Index: /branches/Robocode/HeuristicLab.Problems.Robocode/Interpreter.cs
===================================================================
--- /branches/Robocode/HeuristicLab.Problems.Robocode/Interpreter.cs	(revision 9611)
+++ /branches/Robocode/HeuristicLab.Problems.Robocode/Interpreter.cs	(revision 9612)
@@ -70,4 +70,5 @@
       string cmdOutput = javaCompile.StandardOutput.ReadToEnd();
       cmdOutput += javaCompile.StandardError.ReadToEnd();
+
       //Evaluator.tankStatLog += cmdOutput;
       //Console.WriteLine(cmdOutput);
@@ -79,4 +80,7 @@
 
       javaCompile.WaitForExit();
+      if (javaCompile.ExitCode != 0) {
+        return -1000.0;
+      }
       #endregion
 
@@ -101,14 +105,17 @@
       evaluateCode.Start();
 
-      // instead of p.WaitForExit(), do
       StringBuilder q = new StringBuilder();
       string scoreString = "";
-      while (!evaluateCode.HasExited) {
+      evaluateCode.WaitForExit();
+
+      try {
         scoreString = evaluateCode.StandardOutput.ReadToEnd().Split(
         new string[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries).Last();
         q.Append("Output: " + scoreString + "\r\n");
         q.Append("Error: " + evaluateCode.StandardError.ReadToEnd() + "\r\n");
-      }
-      cmdOutput += q.ToString();
+        cmdOutput += q.ToString();
+      }catch {
+        return -1000.0;
+      }
 
       #endregion
Index: /branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs
===================================================================
--- /branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 9611)
+++ /branches/Robocode/HeuristicLab.Problems.Robocode/Symbols/Event Methods/Events/EmptyEvent.cs	(revision 9612)
@@ -3,42 +3,37 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Problems.Robocode
-{
-    class EmptyEvent: CodeNode
-    {
-        public override int MinimumArity { get { return 0; } }
-        public override int MaximumArity { get { return 0; } }
+namespace HeuristicLab.Problems.Robocode {
+  [StorableClass]
+  public class EmptyEvent : CodeNode {
+    public override int MinimumArity { get { return 0; } }
+    public override int MaximumArity { get { return 0; } }
 
-        [Storable]
-        public override string Prefix { get; set; }
+    [Storable]
+    public override string Prefix { get; set; }
 
-        [Storable]
-        public override string Suffix { get; set; }
+    [Storable]
+    public override string Suffix { get; set; }
 
-        [StorableConstructor]
-        private EmptyEvent(bool deserializing) : base(deserializing) { }
-        private EmptyEvent(EmptyEvent original, Cloner cloner)
-            : base(original, cloner)
-        {
-            this.Prefix = "";
-            this.Suffix = "";
-        }
+    [StorableConstructor]
+    private EmptyEvent(bool deserializing) : base(deserializing) { }
+    private EmptyEvent(EmptyEvent original, Cloner cloner)
+      : base(original, cloner) {
+      this.Prefix = "";
+      this.Suffix = "";
+    }
 
-        public EmptyEvent()
-            : base("EmptyEvent", "This is a placeholder for an empty event.")
-        {
-            this.Prefix = "";
-            this.Suffix = "";
-        }
+    public EmptyEvent()
+      : base("EmptyEvent", "This is a placeholder for an empty event.") {
+      this.Prefix = "";
+      this.Suffix = "";
+    }
 
-        public override IDeepCloneable Clone(Cloner cloner)
-        {
-            return new EmptyEvent(this, cloner);
-        }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EmptyEvent(this, cloner);
+    }
 
-        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
-        {
-            return "";
-        }
+    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
+      return "";
     }
+  }
 }