Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewColumnCommandBase.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewColumnCommandBase.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewColumnCommandBase.cs	(revision 9614)
@@ -29,7 +29,6 @@
   [StorableClass]
   public abstract class AddNewColumnCommandBase : ColumnGroupCommandBase {
-    private AddNewColumnCommandBase()
-      : base(null, string.Empty) {
-    }
+    [StorableConstructor]
+    protected AddNewColumnCommandBase(bool deserializing) : base(deserializing) { }
 
     protected AddNewColumnCommandBase(DataSet dataSet, string columnGroupName, string columnName, Type columnType)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDateTimeColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDateTimeColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDateTimeColumnCommand.cs	(revision 9614)
@@ -33,7 +33,6 @@
   [ViewableCommandInfoAttribute("New DateTimeColumn", 1, ColumnGroupState.Active, "Column Commands", Position = 9)]
   public class AddNewDateTimeColumnCommand : AddNewColumnCommandBase {
-    private AddNewDateTimeColumnCommand()
-      : base(null, string.Empty, string.Empty, typeof(DateTimeColumn)) {
-    }
+    [StorableConstructor]
+    protected AddNewDateTimeColumnCommand(bool deserializing) : base(deserializing) { }
 
     public AddNewDateTimeColumnCommand(DataSet dataSet, string columnGroupName)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDoubleColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDoubleColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewDoubleColumnCommand.cs	(revision 9614)
@@ -20,11 +20,7 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
 using HeuristicLab.DataImporter.Data.Model;
-using HeuristicLab.DataImporter.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,7 +29,6 @@
   [ViewableCommandInfoAttribute("New DoubleColumn", 1, ColumnGroupState.Active, "Column Commands", Position = 7)]
   public class AddNewDoubleColumnCommand : AddNewColumnCommandBase {
-    private AddNewDoubleColumnCommand()
-      : base(null, string.Empty, string.Empty, typeof(DoubleColumn)) {
-    }
+    [StorableConstructor]
+    protected AddNewDoubleColumnCommand(bool deserializing) : base(deserializing) { }
 
     public AddNewDoubleColumnCommand(DataSet dataSet, string columnGroupName)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewProgrammableColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewProgrammableColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewProgrammableColumnCommand.cs	(revision 9614)
@@ -32,7 +32,6 @@
   OptionsView = typeof(ProgrammableColumnCommandView))]
   public class AddNewProgrammableColumnCommand : AddNewColumnCommandBase {
-    private AddNewProgrammableColumnCommand()
-      : base(null, string.Empty, string.Empty, typeof(ProgrammableColumn)) {
-    }
+    [StorableConstructor]
+    protected AddNewProgrammableColumnCommand(bool deserializing) : base(deserializing) { }
 
     public AddNewProgrammableColumnCommand(DataSet dataSet, string columnGroupName)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewStringColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewStringColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/AddNewStringColumnCommand.cs	(revision 9614)
@@ -20,11 +20,7 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
 using HeuristicLab.DataImporter.Data.Model;
-using HeuristicLab.DataImporter.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,7 +29,6 @@
   [ViewableCommandInfoAttribute("New StringColumn", 1, ColumnGroupState.Active, "Column Commands", Position = 8)]
   public class AddNewStringColumnCommand : AddNewColumnCommandBase {
-    private AddNewStringColumnCommand()
-      : base(null,string.Empty,string.Empty,typeof(StringColumn)) {
-    }
+    [StorableConstructor]
+    protected AddNewStringColumnCommand(bool deserializing) : base(deserializing) { }
 
     public AddNewStringColumnCommand(DataSet dataSet, string columnGroupName)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnCommandBase.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnCommandBase.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnCommandBase.cs	(revision 9614)
@@ -23,8 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
 using System.Windows.Forms;
-using System.Xml;
-using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
 using HeuristicLab.DataImporter.Data.Model;
@@ -43,6 +40,7 @@
     protected IEnumerable<SortOrder> oldSortOrder;
 
-    private ChangeColumnCommandBase()
-      : base(null, string.Empty, null) {
+    [StorableConstructor]
+    protected ChangeColumnCommandBase(bool deserializing)
+      : base(deserializing) {
       newColumns = new List<ColumnBase>();
       oldColumns = new List<ColumnBase>();
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDateTimeColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDateTimeColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDateTimeColumnCommand.cs	(revision 9614)
@@ -20,9 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Globalization;
 using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
@@ -34,7 +29,6 @@
   [ViewableCommandInfoAttribute("Change to DateTimeColumn", 1, ColumnGroupState.ColumnSelected, "Column Commands", Position = 13)]
   public class ChangeColumnToDateTimeColumnCommand : ChangeColumnCommandBase {
-    private ChangeColumnToDateTimeColumnCommand()
-      : base(null, string.Empty, null, typeof(DateTimeColumn)) {
-    }
+    [StorableConstructor]
+    protected ChangeColumnToDateTimeColumnCommand(bool deserializing) : base(deserializing) { }
 
     public ChangeColumnToDateTimeColumnCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDoubleColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDoubleColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToDoubleColumnCommand.cs	(revision 9614)
@@ -20,9 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Globalization;
 using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
@@ -34,7 +29,6 @@
   [ViewableCommandInfoAttribute("Change to DoubleColumn", 1, ColumnGroupState.ColumnSelected, "Column Commands", Position = 11)]
   public class ChangeColumnToDoubleColumnCommand : ChangeColumnCommandBase {
-    private ChangeColumnToDoubleColumnCommand()
-      : base(null, string.Empty, null, typeof(DoubleColumn)) {
-    }
+    [StorableConstructor]
+    protected ChangeColumnToDoubleColumnCommand(bool deserializing) : base(deserializing) { }
 
     public ChangeColumnToDoubleColumnCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToStringColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToStringColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/ChangeColumnToStringColumnCommand.cs	(revision 9614)
@@ -20,9 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Globalization;
 using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
@@ -34,7 +29,6 @@
   [ViewableCommandInfoAttribute("Change to StringColumn", 1, ColumnGroupState.ColumnSelected, "Column Commands", Position = 12)]
   public class ChangeColumnToStringColumnCommand : ChangeColumnCommandBase {
-    private ChangeColumnToStringColumnCommand()
-      : base(null, string.Empty, null, typeof(StringColumn)) {
-    }
+    [StorableConstructor]
+    protected ChangeColumnToStringColumnCommand(bool deserializing) : base(deserializing) { }
 
     public ChangeColumnToStringColumnCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/CreateTimeSeriesColumnsCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/CreateTimeSeriesColumnsCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/CreateTimeSeriesColumnsCommand.cs	(revision 9614)
@@ -20,14 +20,11 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
+using System.Windows.Forms.DataVisualization.Charting;
+using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
+using HeuristicLab.DataImporter.Data.Model;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.DataImporter.Data;
-using HeuristicLab.DataImporter.Data.Model;
-using System.Windows.Forms.DataVisualization.Charting;
-using System.Drawing;
 
 namespace HeuristicLab.DataImporter.Command {
@@ -37,5 +34,6 @@
   public class CreateTimeSeriesColumnsCommand : ColumnGroupCommandWithAffectedColumnsBase {
     private int addedColumnsCount;
-
+    [StorableConstructor]
+    protected CreateTimeSeriesColumnsCommand(bool deserializing) : base(deserializing) { }
     public CreateTimeSeriesColumnsCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
       : base(dataSet, columnGroupName, affectedColumns) {
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitCategorialColumnCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitCategorialColumnCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitCategorialColumnCommand.cs	(revision 9614)
@@ -23,9 +23,8 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
+using HeuristicLab.DataImporter.Data;
 using HeuristicLab.DataImporter.Data.CommandBase;
+using HeuristicLab.DataImporter.Data.Model;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.DataImporter.Data;
-using HeuristicLab.DataImporter.Data.Model;
 
 namespace HeuristicLab.DataImporter.Command {
@@ -38,7 +37,6 @@
     private const double NOTSETVALUE = 0.0;
 
-    private SplitCategorialColumnCommand()
-      : base(null, string.Empty, -1) {
-    }
+    [StorableConstructor]
+    protected SplitCategorialColumnCommand(bool deserializing) : base(deserializing) { }
 
     public SplitCategorialColumnCommand(DataSet dataSet, string columnGroupName, int columnIndex)
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitDictionaryStyleDataCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitDictionaryStyleDataCommand.cs	(revision 9595)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/ChangeColumnGroup/SplitDictionaryStyleDataCommand.cs	(revision 9614)
@@ -34,8 +34,6 @@
   public class SplitDictionaryStyleDataCommand : ColumnGroupCommandWithAffectedColumnsBase {
     private int addedColumnsCount;
-
-    private SplitDictionaryStyleDataCommand()
-      : base(null, string.Empty, null) {
-    }
+    [StorableConstructor]
+    protected SplitDictionaryStyleDataCommand(bool deserializing) : base(deserializing) { }
 
     public SplitDictionaryStyleDataCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)