Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs	(revision 9539)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.Instances.DataAnalysis-3.3/TableFileParserTest.cs	(revision 9616)
@@ -42,5 +42,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -64,5 +64,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -86,5 +86,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -109,5 +109,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -131,5 +131,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -153,5 +153,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -175,5 +175,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -197,5 +197,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -220,5 +220,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -243,5 +243,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -266,5 +266,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -289,5 +289,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -311,5 +311,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -333,5 +333,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -355,5 +355,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -377,5 +377,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -400,5 +400,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(4, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -421,5 +421,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -443,5 +443,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -465,5 +465,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -487,5 +487,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -508,5 +508,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(3, parser.Rows);
         Assert.AreEqual(4507, parser.Columns);
@@ -529,5 +529,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
@@ -551,5 +551,5 @@
       TableFileParser parser = new TableFileParser();
       try {
-        parser.Parse(tempFileName);
+        parser.Parse(tempFileName, parser.AreColumnNamesInFirstLine(tempFileName));
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);