Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcess2dPeriodic.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcess2dPeriodic.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcess2dPeriodic.cs	(revision 9622)
@@ -83,5 +83,5 @@
           .Concat(new double[] { Math.Log(Math.Sqrt(0.01)) })
           .ToArray(),
-          null);
+          new int[] { 0, 1});
 
       var mt = new MersenneTwister(31415);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessPolyTen.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessPolyTen.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessPolyTen.cs	(revision 9622)
@@ -74,5 +74,5 @@
           -5.0 // noise
         };
-        
+
 
       var covarianceFunction = new CovarianceSum();
@@ -129,5 +129,5 @@
       covarianceFunction.Terms.Add(t5);
 
-      var cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 10));
 
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionDemo.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionDemo.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionDemo.cs	(revision 9622)
@@ -48,5 +48,5 @@
     public GaussianProcessRegressionDemo(string name, ICovarianceFunction covarianceFunction, double[] hyp) {
       this.name = name;
-      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, new int[] { 0 });
     }
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance.cs	(revision 9622)
@@ -48,5 +48,5 @@
     public GaussianProcessRegressionInstance(string name, ICovarianceFunction covarianceFunction, double[] hyp) {
       this.name = name;
-      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 1));
     }
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance1D.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance1D.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance1D.cs	(revision 9622)
@@ -49,5 +49,5 @@
     public GaussianProcessRegressionInstance1D(string name, ICovarianceFunction covarianceFunction, double[] hyp) {
       this.name = name;
-      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 1));
     }
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance2D.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance2D.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessRegressionInstance2D.cs	(revision 9622)
@@ -49,5 +49,5 @@
     public GaussianProcessRegressionInstance2D(string name, ICovarianceFunction covarianceFunction, double[] hyp) {
       this.name = name;
-      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 2));
     }
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso.cs	(revision 9622)
@@ -59,5 +59,5 @@
         covarianceFunction.GetParameterizedCovarianceFunction(
           new double[] { Math.Log(0.1), Math.Log(Math.Sqrt(1)), Math.Log(Math.Sqrt(0.01)) },
-          null);
+          Enumerable.Range(0, 1));
 
       var mt = new MersenneTwister(31415);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso1.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso1.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso1.cs	(revision 9622)
@@ -66,5 +66,5 @@
       covFun.Terms.Add(new CovarianceNoise());
 
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 2));
       var mt = new MersenneTwister();
       var target = Util.SampleGaussianProcess(mt, cov, data);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso2.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso2.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso2.cs	(revision 9622)
@@ -70,5 +70,5 @@
       covFun.Terms.Add(m2);
       covFun.Terms.Add(new CovarianceNoise());
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 4));
 
       var mt = new MersenneTwister();
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso3.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso3.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso3.cs	(revision 9622)
@@ -75,5 +75,5 @@
       covFun.Terms.Add(m3);
       covFun.Terms.Add(new CovarianceNoise());
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, Enumerable.Range(0, 6));
 
       var mt = new MersenneTwister();
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso4.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso4.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso4.cs	(revision 9622)
@@ -66,5 +66,5 @@
       covFun.Terms.Add(new CovarianceNoise());
 
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, new int[] { 0, 6, 8 });
       var mt = new MersenneTwister();
       var target = Util.SampleGaussianProcess(mt, cov, data);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso5.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso5.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso5.cs	(revision 9622)
@@ -69,5 +69,5 @@
       covFun.Terms.Add(m2);
       covFun.Terms.Add(new CovarianceNoise());
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, new int[] { 0, 2, 5, 6, 8, 9 });
 
       var mt = new MersenneTwister();
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso6.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso6.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIso6.cs	(revision 9622)
@@ -80,5 +80,5 @@
       covFun.Terms.Add(m4);
       covFun.Terms.Add(new CovarianceNoise());
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, new int[] { 0, 1, 2, 3, 4, 5, 6, 8 });
 
 
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIsoDependentNoise.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIsoDependentNoise.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSEIsoDependentNoise.cs	(revision 9622)
@@ -66,5 +66,5 @@
           Math.Log(Math.Sqrt(0.01)) // noise
         };
-      var cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covarianceFunction.GetParameterizedCovarianceFunction(hyp, new int[] { 0 });
 
       var mt = new MersenneTwister(31415);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfRQIso.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfRQIso.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfRQIso.cs	(revision 9622)
@@ -71,5 +71,5 @@
       covFun.Terms.Add(new CovarianceNoise());
 
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, new int[] { 0 });
       var mt = new MersenneTwister();
       var target = Util.SampleGaussianProcess(mt, cov, data);
Index: branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfSEIso.cs
===================================================================
--- branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfSEIso.cs	(revision 9566)
+++ branches/HeuristicLab.Problems.GaussianProcessTuning/HeuristicLab.Problems.Instances.DataAnalysis.GaussianProcessRegression/GaussianProcessSumOfSEIso.cs	(revision 9622)
@@ -70,5 +70,5 @@
       covFun.Terms.Add(new CovarianceNoise());
 
-      var cov = covFun.GetParameterizedCovarianceFunction(hyp, null);
+      var cov = covFun.GetParameterizedCovarianceFunction(hyp, new int[] { 0 });
       var mt = new MersenneTwister();
       var target = Util.SampleGaussianProcess(mt, cov, data);